//+------------------------------------------------------------------+
//|                                              PB_Cycles_mod.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   ""
#property description ""
#property description ""

#property indicator_chart_window
#property indicator_buffers 13
#property indicator_plots   13
#property strict

sinput string                 __text_01               = "";                   // --- 3 Envelope MA settings ---

sinput int                       InpPeriod1           = 32;                   // 1 - MA period
sinput int                       InpShift1            = -16;                  // 1 - MA shift 
sinput double                    InpOctave_1          = .78;                  // 1 - Octave value 
sinput int                       InpPeriod2           = 128;                  // 2 - MA period 
sinput int                       InpShift2            = -64;                  // 2 - MA shift
sinput double                    InpOctave_2          = 1.56;                 // 2 - Octave value
sinput int                       InpPeriod3           = 256;                  // 3 - MA period 
sinput int                       InpShift3            = -128;                 // 3 - MA shift
sinput double                    InpOctave_3          = 3.125;                // 3 - Octave value
sinput ENUM_APPLIED_PRICE        InpPrice             = PRICE_CLOSE;          // MA applied price
sinput ENUM_MA_METHOD            InpMaMethod          = MODE_SMA;             // MA method
sinput bool                      InpDouble            = false;                // Enable doubling octave values
sinput int                       InpMaxbars           = 50000;                // Number of bars, look back

sinput string                 __text_02               = "";                   // --- 3 Envelope style settings ---

sinput color                     InpMedian_1          = clrLimeGreen;         // 1 - Color center line
sinput color                     InpEnvelope_1        = clrLimeGreen;         // 1 - Color envelope lines
sinput int                       InpWidth_1           = 2;                    // 1 - Line width center line 
sinput int                       InpWidth_1a          = 1;                    // 1 - Line width envelope lines 
sinput ENUM_LINE_STYLE           InpStyle_1           = STYLE_SOLID;          // 1 - Line style center line
sinput ENUM_LINE_STYLE           InpStyle_1a          = STYLE_DOT;            // 1 - Line style envelope lines


sinput bool                      InpShowFilling       = false;                // 1 - Show fill 
sinput color                     InpFill_1            = clrBlue;              // 1 - Fill color
sinput int                       InpWidth_4           = 0;                    // 1 - Line width fill

sinput color                     InpMedian_2          = clrOrange;            // 2 - Color center line 
sinput color                     InpEnvelope_2        = clrOrange;            // 2 - Color envelope lines 
sinput int                       InpWidth_2           = 3;                    // 2 - Line width center line 
sinput int                       InpWidth_2a          = 1;                    // 2 - Line width envelope lines 
sinput ENUM_LINE_STYLE           InpStyle_2           = STYLE_SOLID;          // 2 - Line style center line
sinput ENUM_LINE_STYLE           InpStyle_2a          = STYLE_DOT;            // 2 - Line style envelope lines

sinput color                     InpMedian_3          = clrBlue;              // 3 - Color center line
sinput color                     InpEnvelope_3        = clrBlue;              // 3 - Color envelope lines
sinput int                       InpWidth_3           = 4;                    // 3 - Line width center line 
sinput int                       InpWidth_3a          = 1;                    // 3 - Line width envelope lines 
sinput ENUM_LINE_STYLE           InpStyle_3           = STYLE_SOLID;          // 3 - Line style center line
sinput ENUM_LINE_STYLE           InpStyle_3a          = STYLE_DOT;            // 3 - Line style envelope lines

sinput string                 __text_03               = "";                   // --- Add additional MAs ---

sinput int                       InpPeriod5           = 64;                   // 4 - MA period
sinput int                       InpShift5            = -32;                  // 4 - MA shift 
sinput color                     InpColor_5           = clrViolet;            // 4 - Color
sinput int                       InpWidth_5           = 2;                    // 4 - Line width envelope lines  
sinput ENUM_LINE_STYLE           InpStyle_5           = STYLE_SOLID;          // 4 - Style

sinput int                       InpPeriod6           = 16;                   // 5 - MA period
sinput int                       InpShift6            = -8;                   // 5 - MA shift 
sinput color                     InpColor_6           = clrSaddleBrown;       // 5 - Color 
sinput int                       InpWidth_6           = 2;                    // 5 - Line width envelope lines 
sinput ENUM_LINE_STYLE           InpStyle_6           = STYLE_SOLID;          // 5 - Style

sinput int                       InpPeriod7           = 8;                    // 6 - MA period
sinput int                       InpShift7            = -4;                   // 6 - MA shift 
sinput color                     InpColor_7           = clrSandyBrown;        // 6 - Color 
sinput int                       InpWidth_7           = 2;                    // 6 - Line width envelope lines 
sinput ENUM_LINE_STYLE           InpStyle_7           = STYLE_SOLID;          // 6 - Style



double IB_MA1[],IB_Upper1[],IB_Lower1[], IB_Fill1[];
double IB_MA2[],IB_Upper2[],IB_Lower2[];
double IB_MA3[],IB_Upper3[],IB_Lower3[];

double IB_MA5[];
double IB_MA6[];
double IB_MA7[];

double MA;
double octaveMultiplier = 1;
int limit;

//datetime newbarTime;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{

   IndicatorSetString (INDICATOR_SHORTNAME,"Cycle Display Indi");
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
   
   //--- indicator buffers mapping
   
   SetIndexBuffer       (0,IB_MA1,INDICATOR_DATA);
   SetIndexStyle        (0, DRAW_LINE, InpStyle_1, InpWidth_1, InpMedian_1);
   
   SetIndexBuffer       (1,IB_Upper1,INDICATOR_DATA);
   SetIndexStyle        (1, DRAW_LINE, InpStyle_1a, InpWidth_1a, InpEnvelope_1);
   
   SetIndexBuffer       (2,IB_Lower1,INDICATOR_DATA);
   SetIndexStyle        (2, DRAW_LINE, InpStyle_1a, InpWidth_1a, InpEnvelope_1);
   
   SetIndexBuffer       (3,IB_Fill1,INDICATOR_DATA);
   SetIndexStyle        (3, DRAW_HISTOGRAM, STYLE_DOT, InpWidth_4, InpFill_1);   
   
   SetIndexBuffer       (4,IB_MA2,INDICATOR_DATA);
   SetIndexStyle        (4, DRAW_LINE, InpStyle_2, InpWidth_2, InpMedian_2);
   
   SetIndexBuffer       (5,IB_Upper2,INDICATOR_DATA);
   SetIndexStyle        (5, DRAW_LINE, InpStyle_2a, InpWidth_2a, InpEnvelope_2);
   
   SetIndexBuffer       (6,IB_Lower2,INDICATOR_DATA);
   SetIndexStyle        (6, DRAW_LINE, InpStyle_2a, InpWidth_2a, InpEnvelope_2);
   
   SetIndexBuffer       (7,IB_MA3,INDICATOR_DATA);
   SetIndexStyle        (7, DRAW_LINE, InpStyle_3, InpWidth_3, InpMedian_3);
   
   SetIndexBuffer       (8,IB_Upper3,INDICATOR_DATA);
   SetIndexStyle        (8, DRAW_LINE, InpStyle_3a, InpWidth_3a, InpEnvelope_3);
   
   SetIndexBuffer       (9,IB_Lower3,INDICATOR_DATA);
   SetIndexStyle        (9, DRAW_LINE, InpStyle_3a, InpWidth_3a, InpEnvelope_3);
   
   SetIndexBuffer       (10,IB_MA5,INDICATOR_DATA);
   SetIndexStyle        (10, DRAW_LINE, InpStyle_5, InpWidth_5, InpColor_5);
   
   SetIndexBuffer       (11,IB_MA6,INDICATOR_DATA);
   SetIndexStyle        (11, DRAW_LINE, InpStyle_6, InpWidth_6, InpColor_6);
   
   SetIndexBuffer       (12,IB_MA7,INDICATOR_DATA);
   SetIndexStyle        (12, DRAW_LINE, InpStyle_7, InpWidth_7, InpColor_7);
   

   
   ArraySetAsSeries(IB_MA1, true);
   ArraySetAsSeries(IB_Upper1, true);
   ArraySetAsSeries(IB_Lower1, true);
   
   ArraySetAsSeries(IB_MA2, true);
   ArraySetAsSeries(IB_Upper2, true);
   ArraySetAsSeries(IB_Lower2, true);
   
   ArraySetAsSeries(IB_MA3, true);
   ArraySetAsSeries(IB_Upper3, true);
   ArraySetAsSeries(IB_Lower3, true);
   
   ArraySetAsSeries(IB_Fill1, true);
   
   ArraySetAsSeries(IB_MA5, true);
   ArraySetAsSeries(IB_MA6, true);
   ArraySetAsSeries(IB_MA7, true);
   
   if (InpDouble == true){octaveMultiplier = 2.0;}
   
   string comment = "Env1: " + DoubleToString(InpOctave_1*octaveMultiplier, 9) + "; ";
   comment = comment + "Env2: " + DoubleToString(InpOctave_2*octaveMultiplier, 9) + "; ";
   comment = comment + "Env3: " + DoubleToString(InpOctave_3*octaveMultiplier, 9) + "; ";
   Comment(comment);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
//---
   RefreshRates();
   
   if(IsStopped())  {return(0); Alert("return");}
   
   limit = InpMaxbars;
   if (rates_total < InpMaxbars)
   {
      limit = rates_total-1;
   }
   
   for(int i = 0; i < rates_total; i++)
   {  
      IB_MA1    [i]=EMPTY_VALUE;
      IB_Upper1 [i]=EMPTY_VALUE;
      IB_Lower1 [i]=EMPTY_VALUE;
      IB_Fill1  [i]=EMPTY_VALUE;
      
      IB_MA2    [i]=EMPTY_VALUE;
      IB_Upper2 [i]=EMPTY_VALUE;
      IB_Lower2 [i]=EMPTY_VALUE;
      
      IB_MA3    [i]=EMPTY_VALUE;
      IB_Upper3 [i]=EMPTY_VALUE;
      IB_Lower3 [i]=EMPTY_VALUE;
      
      IB_MA5    [i]=EMPTY_VALUE;
      IB_MA6    [i]=EMPTY_VALUE;
      IB_MA7    [i]=EMPTY_VALUE;
   }
   
   displayEnvelopes();

//--- return value of prev_calculated for next call
   return(rates_total);
}
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
{
//---
   
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
//---
   
   
}


void displayEnvelopes()
{

   for (int i = limit; i >= MathAbs(InpShift2); i--)
   {  
      MA = iMA(Symbol(), PERIOD_CURRENT, InpPeriod2, 0, InpMaMethod, InpPrice, i - MathAbs(InpShift2));
      
      IB_MA2[i] = MA;
      IB_Upper2[i] = MA + octaveMultiplier * InpOctave_2;
      IB_Lower2[i] = MA - octaveMultiplier * InpOctave_2;

   }
   
   for (int i = limit; i >= MathAbs(InpShift3); i--)
   {  
      MA = iMA(Symbol(), PERIOD_CURRENT, InpPeriod3, 0, InpMaMethod, InpPrice, i - MathAbs(InpShift3));
      
      IB_MA3[i] = MA;
      IB_Upper3[i] = MA + octaveMultiplier * InpOctave_3;
      IB_Lower3[i] = MA - octaveMultiplier * InpOctave_3;
   }
   
   for (int i = limit; i >= MathAbs(InpShift1); i--)
   {  
      
      MA = iMA(Symbol(), PERIOD_CURRENT, InpPeriod1, 0, InpMaMethod, InpPrice, i - MathAbs(InpShift1));
      
      IB_MA1[i] = MA;
      IB_Upper1[i] = MA + octaveMultiplier * InpOctave_1;
      IB_Lower1[i] = MA - octaveMultiplier * InpOctave_1;
      if (InpShowFilling == true)
      {
         IB_Fill1 [i] = IB_Upper1[i];
      }

   }
   
   for (int i = limit; i >= MathAbs(InpShift5); i--)
   {  
      MA = iMA(Symbol(), PERIOD_CURRENT, InpPeriod5, 0, InpMaMethod, InpPrice, i - MathAbs(InpShift5));
      
      IB_MA5[i] = MA;
      
   } 
   
   for (int i = limit; i >= MathAbs(InpShift6); i--)
   {  
      MA = iMA(Symbol(), PERIOD_CURRENT, InpPeriod6, 0, InpMaMethod, InpPrice, i - MathAbs(InpShift6));
      
      IB_MA6[i] = MA;
      
   }
   
   for (int i = limit; i >= MathAbs(InpShift7); i--)
   {  
      MA = iMA(Symbol(), PERIOD_CURRENT, InpPeriod7, 0, InpMaMethod, InpPrice, i - MathAbs(InpShift7));
      
      IB_MA7[i] = MA;
      
   }


}


